#include "hashmgr.hxx"
#include "affixmgr.hxx"
#include "suggestmgr.hxx"
#include "csutil.hxx"

#define NOCAP   0
#define INITCAP 1
#define ALLCAP  2
#define HUHCAP  3


#ifndef _MYSPELLMGR_HXX_
#define _MYSPELLMGR_HXX_

class MySpell
{
  AffixMgr*       pAMgr;
  HashMgr*        pHMgr;
  SuggestMgr*     pSMgr;
  char *          encoding;
  struct cs_info * csconv;
  int             putstate;
  char *          prevword;
  char *          putword;
  char *	  prevroot;
  int             prevcompound;
  int		  forbidden_compound;
  int             checkdoublewords;
  
public:
  MySpell(const char * affpath, const char * dpath);
  ~MySpell();

  int suggest(char*** slst, const char * word);
  int spell(const char *);
  char * get_dic_encoding();
  char * get_wordchars();
  struct cs_info * get_csconv();
  char * get_prevroot();
  int get_prevcompound();
  
private:
   int    cleanword(char *, const char *, int *, int *);
   void   mkinitcap(char *);
   void   mkallcap(char *);
   void   mkallsmall(char *);
   struct hentry * check(const char *);
};

#endif
